include( "OnTheFlyCinematic.lua" )
include( "Tutorial1Stage2.lua" )

class 'Tutorial1Stage1' (State)

function Tutorial1Stage1:__init( )

	Entity.add("fed_effectsS.odf", 1, Vector(0, 0, 0))
	starbase = Entity.add("fed_OutpostY.odf", 1, Vector(4653, 0, 1574))
	const = EntityFinder( function(e) return e:isType(Entity.Type.GameObject) and e.label == "const" end ):findOne()
	freight = EntityFinder( function(e) return e:isType(Entity.Type.GameObject) and e.label == "freight" end ):findOne()
	repair = EntityFinder( function(e) return e:isType(Entity.Type.GameObject) and e.label == "repair" end ):findOne()
	dil = EntityFinder( function(e) return e:isType(Entity.Type.GameObject) and e.label == "dil" end ):findOne()
	tri = EntityFinder( function(e) return e:isType(Entity.Type.GameObject) and e.label == "tri" end ):findOne()

	--Control Vars
	CinNum = 4
	
	
end

function Tutorial1Stage1:onEnter( machine )

	self.stateMachine = machine
	
	Cineractive.active = true
	Cineractive.skippable = true
	Cineractive:fadeIn( 5.0 )		
	Objectives:load( "Tutorial1Stage1Objectives.txt" ) 	
	UI:addTitle( "Star Trek Armada II: Fleet Operations 3.2.6", 50, 50, 4.0, true )
	UI:addTitle( "Tutorial I: United Federation of Planets", 75, 100, 3.5, true ) 
	Media:playMusic( "Tutorial1Intro.wav" )

	function Cin0( hook, arg)
		if starbase.valid then
			CinNum = 3
			Cineractive:fadeIn( 3.0 )
			Cineractive:lookFrom( Path("path_1"), 0.3 )								
			Cineractive:lookAt( starbase )
			UI:addTitle( "Federation Outpost", 700, 1000, 3.0, true )
		end
	end
	function Cin1( hook, arg)
		if const.valid then
			CinNum = 2
			Cineractive:fadeIn( 1.0 )
			Cineractive:lookFrom( Path("path_2"), 0.25 )								
			Cineractive:lookAt( const )
			UI:addTitle( "Mediterranean Class", 700, 1000, 3.0, true )
		end
	end
	function Cin2( hook, arg)
		if freight.valid then
			CinNum = 1
			Cineractive:fadeIn( 1.0 )
			Cineractive:lookFrom( Path("path_3"), 0.25 )								
			Cineractive:lookAt( freight )
			UI:addTitle( "Mandril Class", 700, 1000, 3.0, true )
		end
	end
	function Cin3( hook, arg)
		if repair.valid then
			CinNum = 0
			Cineractive:fadeIn( 1.0 )
			Cineractive:lookFrom( Path("path_4"), 0.25 )								
			Cineractive:lookAt( repair )
			UI:addTitle( "Newton Class", 700, 1000, 3.0, true )
		end
	end
	function CinFade() 
		Cineractive:fadeOut( 1.0 ) 
		if CinNum == 0 then
			Cineractive.active = false 
			Camera:center( starbase ) 
			Objectives:load( "Tutorial1Stage1Objectives.txt" ) 
			Objectives.visible = true 
			Media:playMusic( "Tutorial1Stage1.wav" )
		end
	end
	--Where all the cinematic jazz happens...
	Timer( "Cin0", 0, Timer.State.Started ):hook( "Cin0", self, Cin0, nil )
	Timer( "fader", 15, Timer.State.Started ):hook( "fader", nil, CinFade, nil )
	Timer( "Cin1", 16, Timer.State.Started ):hook( "Cin1", self, Cin1, nil )
	Timer( "fader", 22, Timer.State.Started ):hook( "fader", nil, CinFade, nil )
	Timer( "Cin2", 23, Timer.State.Started ):hook( "Cin2", self, Cin2, nil )
	Timer( "fader", 30, Timer.State.Started ):hook( "fader", nil, CinFade, nil )
	Timer( "Cin3", 31, Timer.State.Started ):hook( "Cin3", self, Cin3, nil )
	Timer( "fader", 37, Timer.State.Started ):hook( "fader", nil, CinFade, nil )

	--Down to buisness begin Stage 1...
	function checkDil( monitor, amount )
		return Player( 1 ).resources.dilithium >= amount
	end
	function checkTri( monitor, amount )
		return Player( 1 ).resources.latinum >= amount
	end		
	function checkSup( monitor, amount )
		return Player( 1 ).resources.biomatter >= amount
	end	
	function StorageDockDone( monitor, arg )
		return EntityFinder( function(e) 
								return e.odf == "fed_storage_dock.odf" and 
									   e.player.number == 1
								end ):findOne() ~= nil
	end
	function completeObjective( monitor, hook )
		Objectives.objectives[hook.argument].state = true
		Objectives.visible = true
		monitor:stop()
	end

	function Stage1Done( monitor, arg )
		return Objectives.objectives[1].state and
			   Objectives.objectives[2].state and
			   Objectives.objectives[3].state and
			   Objectives.objectives[4].state
	end
	function onStage1Done( monitor, hook )
		Timer.stopAll()
		Monitor.stopAll()
		machine:setState( Tutorial1Stage2() )
	end	

	Monitor( "StorageDockDone", false, nil, StorageDockDone, nil ):hook( "completeObjective", MonitorHook.Type.OnTrue, nil, completeObjective, 1 )
	Monitor( "checkDil", false, nil, checkDil, 1000 ):hook( "completeObjective", MonitorHook.Type.OnTrue, nil, completeObjective, 2 )
	Monitor( "checkTri", false, nil, checkTri, 1000 ):hook( "completeObjective", MonitorHook.Type.OnTrue, nil, completeObjective, 3 )
	Monitor( "checkSup", false, nil, checkSup, 150 ):hook( "completeObjective", MonitorHook.Type.OnTrue, nil, completeObjective, 4 )
	Monitor( "Stage1Done", false, nil, Stage1Done, nil ):hook( "onStage1Done", MonitorHook.Type.OnTrue, nil, onStage1Done, nil )

	TextInput:hook( "stage2", self, onStage1Done, nil, "^stage2$" )

end

function Tutorial1Stage1:onCineractiveEnd( forced )
	if( forced ) then
		Media:stopSounds( )
		Media:playMusic( "Tutorial1Stage1.wav" )
		Timer.stopAll( )
		Cineractive.active = false 
		Camera:center( starbase ) 
		Objectives:load( "Tutorial1Stage1Objectives.txt" ) 
		Objectives.visible = true 
	end

end
