include( "OnTheFlyCinematic.lua" )
include( "Tutorial1Stage3.lua" )

--Major bug, building phaser platform crashes wt?
class 'Tutorial1Stage2' (State)

function Tutorial1Stage2:__init( )
	if starbase.valid then
		Entity.remove(starbase)
	end
	starbase = Entity.add("fed_OutpostY.odf", 1, Vector(4653, 0, 1574))

end

function Tutorial1Stage2:onEnter( machine )

	self.stateMachine = machine
	
	--Cinematic Shots for Stage 2...
	function Stage2Cin0()
		Cineractive.active = true
		Cineractive:fadeIn( 3.0 )
		Cineractive:lookFrom( Path("path_5"), 0.425 )								
		Cineractive:lookAt( starbase )
		Objectives:load( "Tutorial1Stage2Objectives.txt" ) 
		UI:addTitle( "Economy Stage Complete!", 400, 1000, 3.0, true )
		Media:playMusic( "Tutorial1Stage2.wav" )

	end
	function Stage2Cin1()
			antares = EntityFinder( function(e) return e.odf == string.lower("fed_antares_yardY.odf") end ):findOne()
			--OnTheFlyCinematic( entity, xmul, ymul , zmul, ShotValue, Speed )
			OnTheFlyCinematic( antares, 1, 2.5, 3, 3, 0.25 )
			UI:addTitle( "Antares Type Yard", 700, 1000, 3.0, true )
	end
	function Stage2Cin2()
			platform = EntityFinder( function(e) return e.odf == string.lower("fed_platformY.odf") end ):findOne()
			--OnTheFlyCinematic( entity, xmul, ymul , zmul, ShotValue, Speed )
			OnTheFlyCinematic( platform, 0.75, 0.75, 1.5, 2, 0.1 )
			UI:addTitle( "Defense Platform", 700, 1000, 3.0, true )
	end
	function KCin() 
		Cineractive.active = false 
		Camera:center( starbase ) 
		Objectives.visible = true 
	end	

	function AntaresYDone( monitor, arg )
		return EntityFinder( function(e) 
								return e.odf == string.lower("fed_antares_yardY.odf")
								end ):findOne() ~= nil
	end	
	function PlatformDone( monitor, arg )
		return EntityFinder( function(e) 
						return e.odf == string.lower("fed_platformY.odf") 
						end ):findOne() ~= nil
	end
	function PlatformCine( monitor, arg )
		return EntityFinder( function(e) 
								return e.odf == string.lower("fed_platformY.odf")
								end ):findOne() ~= nil
	end	
	function PlatfoCinema( monitor, arg )
			Timer.stopAll( )
			Timer( "Stage2Cin2", 1, Timer.State.Started ):hook( "Stage2Cin2", self, Stage2Cin2, nil )
			Timer( "KCin", 12, Timer.State.Started ):hook( "KCin", self, KCin, nil )
	end
	function SaberClaDone( monitor, arg )
		return EntityFinder( function(e) 
								return e.odf == string.lower("fed_saberY.odf")
								end ):findOne() ~= nil
	end
	function PhaserPlDone( monitor, arg )
		return EntityFinder( function(e) 
								return e.odf == string.lower("fed_platform_phaser.odf")
								end ):findOne() ~= nil
	end

	function completeObjective( monitor, hook )
		if hook.argument == 1 then
			Timer.stopAll( )
			Timer( "Stage2Cin1", 1, Timer.State.Started ):hook( "Stage2Cin1", self, Stage2Cin1, nil )
			Timer( "KCin", 12, Timer.State.Started ):hook( "KCin", self, KCin, nil )
		end
		Objectives.objectives[hook.argument].state = true
		Objectives.visible = true
		monitor:stop()
	end
	function Stage2Done( monitor, arg )
		return Objectives.objectives[3].state and
			   Objectives.objectives[4].state	
	end
	function onStage2Done( monitor, hook )
		Timer.stopAll()
		--Used to skip to stage 2 without errors
		Monitor.stopAll()
		--Changing files to avoid clutter
		machine:setState( Tutorial1Stage3() )
	end	
	
	--First Cinematic Sequence in Stage 2... others triggered with objectives
	Timer( "Stage2Cin0", 0, Timer.State.Started ):hook( "Stage2Cin0", self, Stage2Cin0, nil )
	Timer( "KCin", 15, Timer.State.Started ):hook( "KCin", self, KCin, nil )

	Monitor( "AntaresYDone", false, nil, AntaresYDone, nil ):hook( "completeObjective", MonitorHook.Type.OnTrue, nil, completeObjective, 1 )	
	Monitor( "PlatformDone", false, nil, PlatformDone, nil ):hook( "completeObjective", MonitorHook.Type.OnTrue, nil, completeObjective, 2 )	
	Monitor( "SaberClaDone", false, nil, SaberClaDone, nil ):hook( "completeObjective", MonitorHook.Type.OnTrue, nil, completeObjective, 3 )	
	Monitor( "PhaserPlDone", false, nil, PhaserPlDone, nil ):hook( "completeObjective", MonitorHook.Type.OnTrue, nil, completeObjective, 4 )
	Monitor( "PlatformCine", false, nil, PlatformCine, nil ):hook( "completeObjective", MonitorHook.Type.OnTrue, nil, PlatfoCinema, nil )		
	Monitor( "Stage2Done", false, nil, Stage2Done, nil ):hook( "onStage2Done", MonitorHook.Type.OnTrue, nil, onStage2Done, nil )

	TextInput:hook( "stage3", self, onStage2Done, nil, "^stage3$" )

end

function Tutorial1Stage2:onCineractiveEnd( forced )
	if( forced ) then
		Timer.stopAll( )
		Cineractive.active = false
		Camera:center( const ) 
		Objectives.visible = true 
	end

end
