include( "OnTheFlyCinematic.lua" )
include( "Tutorial1Stage4.lua" )

class 'Tutorial1Stage3' (State)

function Tutorial1Stage3:__init( )
	if starbase.valid then
		Entity.remove(starbase)
	end
	starbase = Entity.add("fed_OutpostY.odf", 1, Vector(4653, 0, 1574))
end

function Tutorial1Stage3:onEnter( machine )

	self.stateMachine = machine

	--Cinematic Shots for Stage 3...
	function Stage3Cin0()
		OnTheFlyCinematic( starbase, (-12), 8, 7, 3, 0.45 )
		Objectives:load( "Tutorial1Stage3Objectives.txt" ) 
		UI:addTitle( "Inital Shipyard Construction and Defense Complete!", 400, 1000, 3.0, true )	
		Media:playMusic( "Tutorial1Stage3.wav" )
	end
	function Stage3Cin1()
			science = EntityFinder( function(e) return e.odf == string.lower("fed_sf_scienceY.odf") end ):findOne()
			--OnTheFlyCinematic( entity, xmul, ymul , zmul, ShotValue, Speed )
			OnTheFlyCinematic( science, 2, 4, 3, 3, 0.35 )
			UI:addTitle( "Starfleet Science", 700, 1000, 3.0, true )
	end
	function Stage3Cin2()
			enginee = EntityFinder( function(e) return e.odf == string.lower("fed_sf_engineeringY.odf") end ):findOne()
			--OnTheFlyCinematic( entity, xmul, ymul , zmul, ShotValue, Speed )
			OnTheFlyCinematic( enginee, 1.5, 2, 3, 2, 0.15 )
			UI:addTitle( "Starfleet Engineering", 700, 1000, 3.0, true )
	end
	function Stage3Cin3()
			eraudiy = EntityFinder( function(e) return e.odf == string.lower("fed_eraudi_yardY.odf") end ):findOne()
			--OnTheFlyCinematic( entity, xmul, ymul , zmul, ShotValue, Speed )
			OnTheFlyCinematic( eraudiy, 1, 4, 3, 3, 0.2 )
			UI:addTitle( "Eraudi Type Yard", 700, 1000, 3.0, true )
	end
	
	function KCin() 
		Cineractive.active = false 
		Camera:center( starbase ) 
		Objectives.visible = true 
	end	

	function ScienceDone( monitor, arg )
		return EntityFinder( function(e) 
								return e.odf == string.lower("fed_sf_scienceY.odf")
								end ):findOne() ~= nil
	end
	function EngineeDone( monitor, arg )
		return EntityFinder( function(e) 
								return e.odf == string.lower("fed_sf_engineeringY.odf")
								end ):findOne() ~= nil
	end
	function EraudiYDone( monitor, arg )
		return EntityFinder( function(e) 
								return e.odf == string.lower("fed_eraudi_yardY.odf")
								end ):findOne() ~= nil
	end
	function ExcelsiDone( monitor, arg )
		return EntityFinder( function(e) 
								return e.odf == string.lower("fed_excelsioriiY.odf")
								end ):findOne() ~= nil
	end

	
	function completeObjective( monitor, hook )
		if hook.argument == 1 then
			Timer.stopAll( )
			Timer( "Stage3Cin1", 1, Timer.State.Started ):hook( "Stage3Cin1", self, Stage3Cin1, nil )
			Timer( "KCin", 12, Timer.State.Started ):hook( "KCin", self, KCin, nil )
		end
		if hook.argument == 2 then
			Timer.stopAll( )
			Timer( "Stage3Cin2", 1, Timer.State.Started ):hook( "Stage3Cin2", self, Stage3Cin2, nil )
			Timer( "KCin", 12, Timer.State.Started ):hook( "KCin", self, KCin, nil )
		end
		if hook.argument == 3 then
			Timer.stopAll( )
			Timer( "Stage3Cin3", 1, Timer.State.Started ):hook( "Stage3Cin3", self, Stage3Cin3, nil )
			Timer( "KCin", 12, Timer.State.Started ):hook( "KCin", self, KCin, nil )
		end		
		Objectives.objectives[hook.argument].state = true
		Objectives.visible = true
		monitor:stop()
	end

	--First Cinematic Sequence in Stage 3... others triggered with objectives
	Timer( "Stage3Cin0", 0, Timer.State.Started ):hook( "Stage3Cin0", self, Stage3Cin0, nil )
	Timer( "KCin", 15, Timer.State.Started ):hook( "KCin", self, KCin, nil )

	function Stage3Done( monitor, arg )
		return Objectives.objectives[3].state and
			   Objectives.objectives[4].state	
	end
	function onStage3Done( monitor, hook )
		Timer.stopAll()
		--Used to skip to stage 2 without errors
		Monitor.stopAll()
		--Changing files to avoid clutter
		machine:setState( Tutorial1Stage4() )
	end	
	
	Monitor( "ScienceDone", false, nil, ScienceDone, nil ):hook( "completeObjective", MonitorHook.Type.OnTrue, nil, completeObjective, 1 )	
	Monitor( "EngineeDone", false, nil, EngineeDone, nil ):hook( "completeObjective", MonitorHook.Type.OnTrue, nil, completeObjective, 2 )	
	Monitor( "EraudiYDone", false, nil, EraudiYDone, nil ):hook( "completeObjective", MonitorHook.Type.OnTrue, nil, completeObjective, 3 )	
	Monitor( "ExcelsiDone", false, nil, ExcelsiDone, nil ):hook( "completeObjective", MonitorHook.Type.OnTrue, nil, completeObjective, 4 )	
	Monitor( "Stage3Done", false, nil, Stage3Done, nil ):hook( "onStage3Done", MonitorHook.Type.OnTrue, nil, onStage3Done, nil )

	--Dev Toolz
	TextInput:hook( "stage4", self, onStage3Done, nil, "^stage4$" )

end

function Tutorial1Stage3:onCineractiveEnd( forced )
	if( forced ) then
		Timer.stopAll( )
		Cineractive.active = false
		Camera:center( const ) 
		Objectives.visible = true 
	end

end
