include( "OnTheFlyCinematic.lua" )

class 'Tutorial1Stage4' (State)

function Tutorial1Stage4:__init( )
	if starbase.valid then
		Entity.remove(starbase)
	end
	starbase = Entity.add("fed_OutpostY.odf", 1, Vector(4653, 0, 1574))
end

function Tutorial1Stage4:onEnter( machine )

	self.stateMachine = machine 
	--Cinematic Shots for Stage 4...
	function Stage4Cin0()
		OnTheFlyCinematic( starbase, 10, (-14), 12, 3, 0.5 )
		Objectives:load( "Tutorial1Stage4Objectives.txt" ) 
		UI:addTitle( "Research & Shipyard Construction Complete, Congradulations!", 400, 1000, 3.0, true )
		Media:playMusic( "Tutorial1Stage4.wav" )
	end
	function Stage4Cin1()
			sfcommand = EntityFinder( function(e) return e.odf == string.lower("fed_sf_commandY.odf") end ):findOne()
			--OnTheFlyCinematic( entity, xmul, ymul , zmul, ShotValue, Speed )
			OnTheFlyCinematic( sfcommand, 2, 4, 3, 3, 0.35 )
			UI:addTitle( "Starfleet Command: Strategic Relocation Center", 700, 1000, 3.0, true )
	end
	function Stage4Cin2()
			support = EntityFinder( function(e) 
							return e.odf == string.lower("fed_descent.odf") or
							e.odf == string.lower("fed_rhodeisland.odf") or
							e.odf == string.lower("fed_nebula_eng.odf") or
							e.odf == string.lower("fed_ambassador.odf") or
							e.odf == string.lower("fed_teutoburg.odf") or
							e.odf == string.lower("fed_excelsior.odf") or
							e.odf == string.lower("fed_centaur.odf") or
							e.odf == string.lower("fed_galaxy.odf") or
							e.odf == string.lower("fed_nebula.odf")
						end ):findOne()
			--OnTheFlyCinematic( entity, xmul, ymul , zmul, ShotValue, Speed )
			OnTheFlyCinematic( support, 1, 2, 2, 3, 0.35 )
			UI:addTitle( "Starfleet Support", 700, 1000, 3.0, true )
			Media:playMusic( "Tutorial1Success.wav" )

	end
	
	function KCin() 
		Cineractive.active = false 
		Camera:center( starbase ) 
		Objectives.visible = true 
	end	
	function CommandDone( monitor, arg )
		return EntityFinder( function(e) 
								return e.odf == string.lower("fed_sf_commandY.odf") or 
								e.odf == string.lower("fed_sf_commandZ.odf") 
								end ):findOne() ~= nil
	end
	function SupportDone( monitor, arg )
		return EntityFinder( function(e) 
							return e.odf == string.lower("fed_descent.odf") or
							e.odf == string.lower("fed_rhodeisland.odf") or
							e.odf == string.lower("fed_nebula_eng.odf") or
							e.odf == string.lower("fed_ambassador.odf") or
							e.odf == string.lower("fed_teutoburg.odf") or
							e.odf == string.lower("fed_excelsior.odf") or
							e.odf == string.lower("fed_centaur.odf") or
							e.odf == string.lower("fed_galaxy.odf") or
							e.odf == string.lower("fed_nebula.odf")
						end ):findOne() ~= nil
	end

	function completeObjective( monitor, hook )
		if hook.argument == 1 then
			Timer.stopAll( )
			Objectives.visible = true
			Timer( "Stage4Cin1", 1, Timer.State.Started ):hook( "Stage4Cin1", self, Stage4Cin1, nil )
			Timer( "KCin", 12, Timer.State.Started ):hook( "KCin", self, KCin, nil )
		end
		Objectives.objectives[hook.argument].state = true
		monitor:stop()
	end
	function MissionSuccess() 
		UI:addTitle( "Success! You Have Completed Tutorial I: The United Federation of Planets", 300, 1000, 4.0, true )
		Cineractive:fadeOut( 6.0 )
		Mission:finish( true, 6 )
	end	
	
	--First Cinematic Sequence in Stage 3... others triggered with objectives
	Timer( "Stage4Cin0", 0, Timer.State.Started ):hook( "Stage4Cin0", self, Stage4Cin0, nil )
	Timer( "KCin", 15, Timer.State.Started ):hook( "KCin", self, KCin, nil )

	function Stage4Done( monitor, arg )
		return Objectives.objectives[1].state and
			   Objectives.objectives[2].state	
	end
	function onStage4Done( monitor, hook )
		Timer.stopAll()
		Monitor.stopAll()
		Timer( "Stage4Cin2", 15, Timer.State.Started ):hook( "Stage4Cin2", self, Stage4Cin2, nil )
		Timer( "Finish", 25, Timer.State.Started ):hook( "MissionSuccess", self, MissionSuccess, nil )
		
	end	
	
	Monitor( "CommandDone", false, nil, CommandDone, nil ):hook( "completeObjective", MonitorHook.Type.OnTrue, nil, completeObjective, 1 )	
	Monitor( "SupportDone", false, nil, SupportDone, nil ):hook( "completeObjective", MonitorHook.Type.OnTrue, nil, completeObjective, 2 )	
	Monitor( "Stage4Done", false, nil, Stage4Done, nil ):hook( "onStage4Done", MonitorHook.Type.OnTrue, nil, onStage4Done, nil )

	--Dev Toolz

end

function Tutorial1Stage4:onCineractiveEnd( forced )
	if( forced ) then
		Timer.stopAll( )
		Cineractive.active = false
		Camera:center( const ) 
		Objectives.visible = true 
		if Objectives.objectives[1].state and Objectives.objectives[2].state then
		Mission:finish( true, 0 )
		end
	end

end
